(******************************************************************************
   These types (id, unop, binop) are used by the parser.  You do not want to
   change them.
 ******************************************************************************)

type id = string

type unop =
  | UopMinus
  | UopNot
  | UopTypeof
  | UopDeref

type binop =
  | BopPlus
  | BopMinus
  | BopTimes
  | BopDiv
  | BopMod
  | BopLt
  | BopLeq
  | BopGt
  | BopGeq
  | BopEq
  | BopNeq
  | BopEqStrict
  | BopNeqStrict
  | BopAssign

(******************************************************************************
   [surface_expr] is the type of the AST for the surface language of
   expressions. You may implement this type however you wish.  Use the example
   interpreters seen in lecture and lab as inspiration.
 ******************************************************************************)

type surface_expr = unit

(******************************************************************************
   [surface_defn] is the type of the AST for the surface language of
   definitions. You may implement this type however you wish.  There is
   only one kind of definition---the let [rec] definition---so this type
   can be quite simple.
 ******************************************************************************)

type surface_defn = unit

(******************************************************************************
   [core_expr] is the type of the AST for the core language of
   expressions. You may implement this type however you wish.  It
   will be very similar to [surface_expr].
 ******************************************************************************)

type core_expr = unit

(******************************************************************************
   [core_defn] is the type of the AST for the core language of
   definitions. You may implement this type however you wish.  It
   will be very similar to [surface_defn].
 ******************************************************************************)

type core_defn = unit

(******************************************************************************
   These types (surface_phrase, core_phrase) are used by the parser.  You do
   not want to change them.
 ******************************************************************************)

type surface_phrase =
  | SExpr of surface_expr
  | SDefn of surface_defn

type core_phrase =
  | CExpr of core_expr
  | CDefn of core_defn
