#!/bin/bash
# DO NOT EDIT THIS FILE

zip=good

if [ -e a4src.zip ]; then
  echo "a4src.zip exists.  Good."
  if zipinfo -1 a4src.zip | grep -q "^eval.ml$"; then
    echo "eval.ml is in the root folder of the zip.  Good."
  else 
    echo "eval.ml is NOT in the root folder of the zip.  This is bad."
    echo "Did you create the zip by running \"make zip\"?"
  zip=bad
fi
else
  echo "a4src.zip does NOT exist.  This is bad.  Have you run \"make zip\"?"
  zip=bad
fi

if [[ "$zip" == good ]]; then
  cat <<EOF
===========================================================
Your zip file looks good to me.  Congratulations!
===========================================================

I checked to make sure your zip contains at least one of
your source files, but I can't check to make sure it contains
all of them, because I can't know what modules or test files
you might have added.  As long as you created the zip by running 
"make zip", it will have them.  But just in case you want to 
double check, here are all the files I found in your zip:

EOF
  zipinfo -1 a4src.zip
else
  cat <<EOF
===========================================================
WARNING

Your zip file looks broken to me.  The code that
you submit might not compile on the grader's machine,
leading to heavy penalties.  Please fix your zip file.
Check the error messages above carefully to determine 
what is wrong with your file.  The most common mistake
is creating the zip using your OS's file browser, instead
of using "make zip".  See a consultant for help if you 
cannot determine what is wrong.
===========================================================
EOF
fi