(* [Error] is raised by functions in this module to signal an error
   encountered during desugaring that prevents further evaluation. *)
exception Error of string

(* [desugar_expr e] desugars [e] from the surface language to the core.
   raises: [Error _] if [e] cannot be desugared. *)
val desugar_expr : Ast.surface_expr -> Ast.core_expr

(* [desugar_defn d] desugars [d] from the surface language to the core.
   raises: [Error _] if [d] cannot be desugared. *)
val desugar_defn : Ast.surface_defn -> Ast.core_defn

(* [desugar_phrase p] desugars [p] from the surface language to the core.
   raises: [Error _] if [p] cannot be desugared. *)
val desugar_phrase : Ast.surface_phrase -> Ast.core_phrase
